#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#define PIC_DBG

#include "callbacks.h"
#include "picdialog.h"
#include "main.h"

// meta-callback for size changes in an picture
static void
on_ct_change(GtkWidget *pict_hbox, gint ct)
{
  GtkWidget *dialog;
  gint32 layer;
  gint   layer_num;
  gint  *calc_type;

  dialog      = gtk_widget_get_toplevel(pict_hbox);
  layer       = GPOINTER_TO_INT(gtk_object_get_data(GTK_OBJECT(pict_hbox), 
						    "pict_layer"));
  layer_num   = GPOINTER_TO_INT(gtk_object_get_data(GTK_OBJECT(pict_hbox), 
						    "pict_layer_num"));
  calc_type   = gtk_object_get_data(GTK_OBJECT(dialog), 
				    "calc_type");

  if(!calc_type)
    {
      D(("Something's wrong -- can't get calc type from dialog ...\n"));
      return;
    }

  // Update vector entry for later when we're actually saving,
  // and update the preview right away ...
  calc_type[layer_num] = ct;
  pic_specs_dialog_update_pict_preview (dialog, layer, ct);
}


void
on_ok_button_clicked                   (GtkButton       *button,
                                        GtkWidget       *dialog)
{
  gtk_object_set_data (GTK_OBJECT(dialog), "exit_status", GINT_TO_POINTER(1));
  gtk_widget_hide(dialog);
  gtk_main_quit();

  button = NULL;
}


void
on_cancel_button_clicked               (GtkButton       *button,
                                        GtkWidget       *dialog)
{
  gtk_object_set_data (GTK_OBJECT(dialog), "exit_status", GINT_TO_POINTER(0));
  gtk_widget_hide(dialog);
  gtk_main_quit();

  button = NULL;
}


void
on_ti73_menu_selected                  (GtkWidget       *item,
					GtkWidget       *pict_hbox)
{
  on_ct_change(pict_hbox, CALC_TI73);
  item = NULL;
}

void
on_ti82_menu_selected                  (GtkWidget       *item,
					GtkWidget       *pict_hbox)
{
  on_ct_change(pict_hbox, CALC_TI82);
  item = NULL;
}

void
on_ti83_menu_selected                  (GtkWidget       *item,
					GtkWidget       *pict_hbox)
{
  on_ct_change(pict_hbox, CALC_TI83);
  item = NULL;
}

void
on_ti83p_menu_selected                  (GtkWidget       *item,
					GtkWidget       *pict_hbox)
{
  on_ct_change(pict_hbox, CALC_TI83P);
  item = NULL;
}

void
on_ti85_menu_selected                  (GtkWidget       *item,
					GtkWidget       *pict_hbox)
{
  on_ct_change(pict_hbox, CALC_TI85);
  item = NULL;
}

void
on_ti86_menu_selected                  (GtkWidget       *item,
					GtkWidget       *pict_hbox)
{
  on_ct_change(pict_hbox, CALC_TI86);
  item = NULL;
}

void
on_ti89_menu_selected                  (GtkWidget       *item,
					GtkWidget       *pict_hbox)
{
  on_ct_change(pict_hbox, CALC_TI89);
  item = NULL;
}

void
on_ti92_menu_selected                  (GtkWidget       *item,
					GtkWidget       *pict_hbox)
{
  on_ct_change(pict_hbox, CALC_TI92P);
  item = NULL;
}

void
on_ti92p_menu_selected                  (GtkWidget       *item,
					GtkWidget       *pict_hbox)
{
  on_ct_change(pict_hbox, CALC_TI92P);
  item = NULL;
}

void
on_v200_menu_selected                  (GtkWidget       *item,
					GtkWidget       *pict_hbox)
{
  on_ct_change(pict_hbox, CALC_V200);
  item = NULL;
}
